;**************************************************************************
;*
;* FILE  loader.asm
;* Copyright (c) 2005, 2006 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: loader.asm,v 1.14 2006-09-29 15:44:14 tlr Exp $
;*
;* DESCRIPTION
;*   load and install dtvmon.
;*
;******
	processor 6502

	MAC	sac
	dc.b	$32,{1}
	ENDM
	MAC	sir
	dc.b	$42,{1}
	ENDM
	MAC	bra
	dc.b	$12,{1}-2-.
	ENDM

TARGET	equ	$8000

dest_zp	equ	$fb
src_zp	equ	$fd

	seg	code
	org	$0801
;**************************************************************************
;*
;* Basic line!
;*
;******
StartOfFile:
	dc.w	EndLine
	dc.w	0
	dc.b	$9e,"2069 /T.L.R/",0
;	        0 SYS2069 /T.L.R/
EndLine:
	dc.w	0
SysAddress1:
	jmp	SysAddress

start_head:
	include	"config.asm"
end_conf:
start_conf	equ	start_head+HEADER_LEN
start_conf_mon	equ	$8009+HEADER_LEN
		
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:

; install the monitor
	sei

; restore sysline (if we were newed)
	lda	#<EndLine
	sta	$0801
	lda	#>EndLine
	sta	$0802
	
	sac	$ee
	lda	#6
	sac	$00
sa_sm1:
	bit	$8000
	lda	#$6c
	sta	sa_sm1

	lda	#1
	sta	$d03f
	lda	#%00100000
	sta	$d03c
	sac	$99
	lda	#%00000011
	sac	$00
		
	ldy	#<code_start
	ldx	#>code_start
	jsr	uncrunch

	ldx	#end_conf-start_conf-1
sa_lp2:
	lda	start_conf,x
	sta	start_conf_mon,x
	dex
	bpl	sa_lp2

	ldx	#%00000000
	stx	$d03c
	stx	$d03f
	sac	$99
	txa
	sac	$00

	sac	$ee
	lda	#2
	sac	$00

	cli

; print info, and exit to basic
	ldx	#0
sa_lp3:
	lda	start_msg,x
	beq	sa_ex1
	jsr	$ffd2
	inx
	bne	sa_lp3
sa_ex1:
	jmp	$a474

UL	equ	176
UR	equ	174
DL	equ	173
DR	equ	189
HRZ	equ	195
VRT	equ	194
LCR	equ	171
RCR	equ	179
UCR	equ	178
DCR	equ	177
CRS	equ	219

start_msg:
	dc.b	13
	dc.b	UL
	ds.b	35,HRZ
	dc.b	UR,13
	dc.b	VRT,"DTVMON INSTALLED AT $018000-$01BFFF",VRT,13
	dc.b	VRT,"LBUTTON+RESET OR RUN TO ACTIVATE.  ",VRT,13
	dc.b	DL
	ds.b	35,HRZ
	dc.b	DR,13
	dc.b	0

uncrunch:
	include	"sa_uncrunch_short.asm"
	
code_start:
	incbin	"dtvmon_ram_cr.bin"
code_end:
; eof
